// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from rcgcd_spl_14:msg/RCGCD.idl
// generated code does not contain a copyright notice

#ifndef RCGCD_SPL_14__MSG__DETAIL__RCGCD__FUNCTIONS_H_
#define RCGCD_SPL_14__MSG__DETAIL__RCGCD__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "rcgcd_spl_14/msg/rosidl_generator_c__visibility_control.h"

#include "rcgcd_spl_14/msg/detail/rcgcd__struct.h"

/// Initialize msg/RCGCD message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * rcgcd_spl_14__msg__RCGCD
 * )) before or use
 * rcgcd_spl_14__msg__RCGCD__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
bool
rcgcd_spl_14__msg__RCGCD__init(rcgcd_spl_14__msg__RCGCD * msg);

/// Finalize msg/RCGCD message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
void
rcgcd_spl_14__msg__RCGCD__fini(rcgcd_spl_14__msg__RCGCD * msg);

/// Create msg/RCGCD message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * rcgcd_spl_14__msg__RCGCD__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
rcgcd_spl_14__msg__RCGCD *
rcgcd_spl_14__msg__RCGCD__create();

/// Destroy msg/RCGCD message.
/**
 * It calls
 * rcgcd_spl_14__msg__RCGCD__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
void
rcgcd_spl_14__msg__RCGCD__destroy(rcgcd_spl_14__msg__RCGCD * msg);


/// Initialize array of msg/RCGCD messages.
/**
 * It allocates the memory for the number of elements and calls
 * rcgcd_spl_14__msg__RCGCD__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
bool
rcgcd_spl_14__msg__RCGCD__Sequence__init(rcgcd_spl_14__msg__RCGCD__Sequence * array, size_t size);

/// Finalize array of msg/RCGCD messages.
/**
 * It calls
 * rcgcd_spl_14__msg__RCGCD__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
void
rcgcd_spl_14__msg__RCGCD__Sequence__fini(rcgcd_spl_14__msg__RCGCD__Sequence * array);

/// Create array of msg/RCGCD messages.
/**
 * It allocates the memory for the array and calls
 * rcgcd_spl_14__msg__RCGCD__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
rcgcd_spl_14__msg__RCGCD__Sequence *
rcgcd_spl_14__msg__RCGCD__Sequence__create(size_t size);

/// Destroy array of msg/RCGCD messages.
/**
 * It calls
 * rcgcd_spl_14__msg__RCGCD__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_rcgcd_spl_14
void
rcgcd_spl_14__msg__RCGCD__Sequence__destroy(rcgcd_spl_14__msg__RCGCD__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // RCGCD_SPL_14__MSG__DETAIL__RCGCD__FUNCTIONS_H_
